// ===================================================================
//
// CBP_1421_Btaitenberg_1.c 
//
// 31_12_20 Devel
//
// Playgounrd for Braitenberg Vehicles
//
// ==================================================================

// Webots headers 
#include <webots/robot.h>

// C-function headers   
#include <stdio.h>

// Headers for this module. Helper_1 provides calls to distance sensor,
// light sensor and time-of-flight sensor. Als motor drive function.
#include "CBP_1421_Helper1a.h"
  
// Robot Parameters Speed in rad/sec. Distances in metres.
#define TIME_STEP 16 
#define WHEEL_RADIUS 0.0205
#define AXLE_LENGTH 0.053
#define MAX_SPEED 6.28

// Global variables
double omegaL, omegaR;
double dist_vals[8];
double light_vals[8];
double leftEyeVal, rightEyeVal;

int main(int argc, char **argv) {

  wb_robot_init();

  cbp_motors_init();
  cbp_sensors_init(TIME_STEP);
  
  
  while (wb_robot_step(TIME_STEP) != -1) {
          
    // Get light sensor vals
    cbp_get_lightsensor_vals(light_vals);
    // Assign to left and right eye
    //leftEyeVal  = 
    //rightEyeVal = 
    // Normalize values
    // leftEyeVal  = 
    //rightEyeVal = 
    // Compute motor speeds
    //omegaL = ( + )*MAX_SPEED;
    //omegaR = ( + )*MAX_SPEED;    
    // Drive Motors
    cbp_motors_set_velocity(omegaL,omegaR);

  };

  wb_robot_cleanup();

  return 0;
}
