// ===============================================================
// CBP_1421_Helper1a.h
// 31-12-20
//
// ===============================================================

#ifndef CBP_1421_HELPER1
#define CBP_1421_HELPER1

typedef struct { double x; double y; } LUT;


void cbp_sensors_init(int timeStep);
void cbp_motors_init();
bool delay(double delay);
void cbp_motors_set_velocity(double omegaL, double omegaR);
void cbp_get_distance_vals(double vals[]);
void cbp_get_lightsensor_vals(double vals[]);
double cbp_get_timeOfFlight_vals();

double lookUpDistance(LUT *c, double x);

void blocking_delay(double seconds, int time_step);

#endif