// ===================================================================
//
// CBP_1421_Obstacle_Avoidance_1a.c 
//
// 31_12_20 Devel
//
// Simple FSM for obstacle avoidance using non-blocking delay
//
// ==================================================================
 
// Webots headers 
#include <webots/robot.h>

// C-function headers   
#include <stdio.h>

// Headers for this module. Helper_1 provides calls to distance sensor,
// light sensor and time-of-flight sensor. Als motor drive function.
#include "CBP_1421_Helper1a.h"
  
// Robot Parameters Speed in rad/sec. Distances in metres.
#define TIME_STEP 16 
#define WHEEL_RADIUS 0.0205
#define AXLE_LENGTH 0.053
#define MAX_SPEED 6.28

// states
#define STATE_GO_FORWARD 1
#define STATE_TURN_CLOCK 2
#define STATE_TURN_ANTICLOCK 3
#define STATE_GO_BACKWARD 4
int state;
bool done = false;

// Global variables
double omegaL, omegaR;
double dist_vals[8];
double light_vals[8];

int main(int argc, char **argv) {

  wb_robot_init();

  cbp_motors_init();
  cbp_sensors_init(TIME_STEP);
  
  state = STATE_GO_FORWARD;
  
  while (wb_robot_step(TIME_STEP) != -1) {
          
    // Distance Sensors - Look for collision
    cbp_get_distance_vals(dist_vals);
    //if(dist_vals[0] > -1) printf("d0 = %f\n",dist_vals[0]);
    printf(">>>> STATE = %d omL = %f, omR = %f\n",state,omegaL,omegaR);
    
    // State machine to set motor speeds
    switch(state) {
      case STATE_GO_FORWARD:
        //omegaL = 
        //omegaR = 
       // if(dist_vals[0] < ?? && dist_vals[0] > -1)
       //   state = STATE_GO_BACKWARD;
        break;
        
      case STATE_GO_BACKWARD:
       // omegaL = 
       // omegaR =      
        // hold speed for a time
       // done = delay(??);
       // if(done) {
       //   state = STATE_TURN_CLOCK;
       //   done = false;
       // }
        break;
      case STATE_TURN_CLOCK:
        //omegaL =  
        //omegaR =          
         // hold speed for a time
        //done = delay(??);
        //if(done) {
        //  state = ;
         // done = false;
        //}  
        break;
    }
  
    // Drive Motors
    cbp_motors_set_velocity(omegaL,omegaR);

  };

  wb_robot_cleanup();

  return 0;
}
